#***********************************************************************
# Licensed Material - Property of IBM
#
# 
#
# (c) Copyright IBM Corp. 2009.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************
##################################################################
#
# Deploys Banking ICP ears.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from java.lang import System
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop
#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')

refEarAppNameCCTI_Debulk = prop.getProperty('refEarAppNameCCTI_Debulk')
refEarFileNameCCTI_Debulk = prop.getProperty('refEarFileNameCCTI_Debulk')

refEarAppNameCCTI_Validation = prop.getProperty('refEarAppNameCCTI_Validation')
refEarFileNameCCTI_Validation = prop.getProperty('refEarFileNameCCTI_Validation')

refEarAppNameRules_Engine = prop.getProperty('refEarAppNameRules_Engine')
refEarFileNameRules_Engine = prop.getProperty('refEarFileNameRules_Engine')

refEarAppNameCommentECR = prop.getProperty('refEarAppNameCommentECR')
refEarFileNameCommentECR = prop.getProperty('refEarFileNameCommentECR')

refEarAppNameCorporate_Payments_Process = prop.getProperty('refEarAppNameCorporate_Payments_Process')
refEarFileNameCorporate_Payments_Process = prop.getProperty('refEarFileNameCorporate_Payments_Process')

refEarAppNameCorporate_Payments_Mock_Services = prop.getProperty('refEarAppNameCorporate_Payments_Mock_Services')
refEarFileNameCorporate_Payments_Mock_Services = prop.getProperty('refEarFileNameCorporate_Payments_Mock_Services')
#########################################################################
# Get mediation properties
#########################################################################
mediationAppName = prop.getProperty('mediationAppName')
mediationEarFileName = prop.getProperty('mediationEarFileName')
print "Configuration properties loaded."
#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupName = prop.getProperty('groupName')
groupNameBankManager = prop.getProperty('groupNameBankManager')
userName01 = prop.getProperty('userName01')
userName02 = prop.getProperty('userName02')
surName01 = prop.getProperty('surName01')
surName02 = prop.getProperty('surName02')
userName03 = prop.getProperty('userName03')
surName03 = prop.getProperty('surName03')
userName04 = prop.getProperty('userName04')
surName04 = prop.getProperty('surName04')
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
#
#
#########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')
createCubes = prop.getProperty('createCubes')
startCubes = prop.getProperty('startCubes')
businessSituation = prop.getProperty('businessSituation')
profileMigration = prop.getProperty('profileMigration')

#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
print "The order is: "     
fabricApplicationList = [refEarAppNameCCTI_Debulk, refEarAppNameCCTI_Validation, refEarAppNameRules_Engine, refEarAppNameCorporate_Payments_Process, refEarAppNameCorporate_Payments_Mock_Services, mmAppName, mediationAppName]
print "The List of uninstallable: " + str(fabricApplicationList)
unInstallApplications(fabricApplicationList)

#Deploy the Banking application
#########################################################################
# Install Ref app EAR
#########################################################################
print
print "Installing Reference Implementation application ... " + refEarAppNameCCTI_Debulk
try :
        appOptions = ["-appname", refEarAppNameCCTI_Debulk, "-server", serverName]
	AdminApp.install(refEarFileNameCCTI_Debulk, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppNameCCTI_Debulk"
        sys.stderr.write("Error occured while deploying refEarAppNameCCTI_Debulk")
        raise
       
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppNameCCTI_Debulk)
print "Ear started: " + refEarAppNameCCTI_Debulk
print refEarAppNameCCTI_Debulk + " installed successfully."

print "Installing EAR application ... " + refEarAppNameCCTI_Validation
try :
        appOptions = ["-appname", refEarAppNameCCTI_Validation, "-server", serverName]
	AdminApp.install(refEarFileNameCCTI_Validation, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppNameCCTI_Validation"
        sys.stderr.write("Error occured while deploying refEarAppNameCCTI_Validation")
        raise
        
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppNameCCTI_Validation)
print "Ear started: " + refEarAppNameCCTI_Validation
print refEarAppNameCCTI_Validation + " installed successfully."

print
print "Installing EAR application ... " + refEarAppNameRules_Engine
try :
        appOptions = ["-appname", refEarAppNameRules_Engine, "-server", serverName]
	AdminApp.install(refEarFileNameRules_Engine, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppNameRules_Engine"
        sys.stderr.write("Error occured while deploying refEarAppNameRules_Engine")
        raise
        
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppNameRules_Engine)
print "Ear started: " + refEarAppNameRules_Engine
print refEarAppNameRules_Engine + " installed successfully."

print
print "Installing EAR application ... " + refEarAppNameCorporate_Payments_Process
try :
        appOptions = ["-appname", refEarAppNameCorporate_Payments_Process, "-server", serverName]
	AdminApp.install(refEarFileNameCorporate_Payments_Process, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppNameCorporate_Payments_Process"
        sys.stderr.write("Error occured while deploying refEarAppNameCorporate_Payments_Process")
        raise
       
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppNameCorporate_Payments_Process)
print "Ear started: " + refEarAppNameCorporate_Payments_Process
print refEarAppNameCorporate_Payments_Process + " installed successfully."

print "Installing EAR application ... " + refEarAppNameCorporate_Payments_Mock_Services
try :
        appOptions = ["-appname", refEarAppNameCorporate_Payments_Mock_Services, "-server", serverName]
	AdminApp.install(refEarFileNameCorporate_Payments_Mock_Services, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppNameCorporate_Payments_Mock_Services"
        sys.stderr.write("Error occured while deploying refEarAppNameCorporate_Payments_Mock_Services")
        raise
       
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppNameCorporate_Payments_Mock_Services)
print "Ear started: " + refEarAppNameCorporate_Payments_Mock_Services
print refEarAppNameCorporate_Payments_Mock_Services + " installed successfully."

#########################################################################
# Install Monitor Model EARs
#########################################################################
print
print "Installing Monitor Model application ..."

# The LifecycleClientDatabaseTask task consists of the following 6 fields
# and the acceptable values:
#   "Run scripts to create the schema" = yes or no
#   "Run scripts to enable Data Movement Services" = yes or no
#   "Run scripts to delete the schema during uninstallation" = yes or no
#   "Processing strategy" = SerialST or SerialMT
#   "Enable event reordering" = yes or no
#   "Enable KPI merge from previous version" = yes or no
createSchema = 'yes'
enableDMS = 'no'
deleteSchema = 'yes'
processingStrategy = 'SerialMT'
eventReordering = 'no'
kpiMerge = 'no'
businessSituation = 'yes'
profileMigration = 'no'

 # Alphablox settings

 # 1.  The LifecycleClientAlphabloxTask task consists of the following 8 fields
 # 2. and the acceptable values:
 # 3. "Server location (local/remote)" = local or remote
 # 4. default is local
 # 5. "Host name, ignored if location is local"= hostname
 # 6. "RMI port, ignored if location is local" = port number
 # 7. "Security (enabled/disabled), ignored if location is local" = enabled or disabled
 # 8. default is disabled
 # 9. "User ID, ignored if security is disabled" = user ID
 # 10. "Password, ignored if security is disabled" = password
 # 11. "Create the Alphablox cubes" = yes or no
 # 12. default is yes if Alphablox is local
 # 13. "Start the Alphablox cubes" = should be the same value as "Create the Alphablox cubes"
serverLocation = 'local'
hostName = ''
rmiPort = ''
securityMode = 'enabled'
userid = 'admin'
password = 'admin'
createCubes = 'yes'
startCubes = 'yes'

databaseTaskInfo = [ createSchema, enableDMS, deleteSchema, processingStrategy, eventReordering, kpiMerge, businessSituation, profileMigration ]
alphabloxTaskInfo = [ serverLocation, hostName, rmiPort, securityMode, userid, password, createCubes, startCubes ]

print AdminControl.trace('com.ibm.wbimonitor.*=all=enabled')

print
print "Installing Monitor Model application ..."
# Install Monitor Model EAR
if serverLocation == 'local':
   cellName = cell
   nodeName = node
   serverName = server
elif serverLocation == 'remote':
   print "Installing Monitor Model on remote Monitor server..." 
else:
   print "Please set CEI server location in configration properties file"
   sys.exit(1)

ceiTaskInfo = [ serverLocation, hostName, rmiPort, securityMode, userid, password, \
   eventGroup, cellName, nodeName, serverName, clusterName, distributionMode ]
try :
	AdminApp.install(mmEarFileName,  ['-LifecycleClientDatabaseTask', [databaseTaskInfo], \
	'-LifecycleClientAlphabloxTask', [alphabloxTaskInfo], \
	'-LifecycleClientCEITask', [ceiTaskInfo], '-appname', mmAppName]  )

except :
        print "Exception:Error occured while deploying mmAppName"
        sys.stderr.write("Error occured while deploying mmAppName")
        raise
        print "Deployed Monitor Model ears."
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', mmAppName)
print "Ear started: " + mmAppName
print mmAppName + " installed successfully."
#########################################################################
# Install and start mediation EAR
#########################################################################
print
print "Installing Mediation application ..."
AdminApp.install(mediationEarFileName, "[-appname " + mediationAppName + "]")
AdminConfig.save()
print mediationAppName + " installed successfully."
print "Starting mediation application ..."
AdminControl.invoke(appManager, 'startApplication', mediationAppName)
print "Mediation application started."

#########################################################################
# Creating user and group and their mapping
#########################################################################
print
print "Creating Group and user Name and their mapping ..."
try :
        
	attrGrp = ["-cn",groupName]
	if(len(AdminTask.searchGroups(attrGrp)) > 1):
	    print "Skipping creating group " +  groupName + " as group exists"
	else :
	    AdminTask.createGroup(attrGrp)
	attrGrpBankManager = ["-cn",groupNameBankManager]
	if(len(AdminTask.searchGroups(attrGrpBankManager)) > 1):
	    print "Skipping creating group " +  groupNameBankManager + " as group exists"
	else :
	    AdminTask.createGroup(attrGrpBankManager)
	attrName1 = ["-uid",userName01]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
            print "Skipping creating user " +  userName01 + " as user exists"
	else :
	    appOptions = ["-uid", userName01, "-password", "password", "-confirmPassword", "password", "-cn", userName01, "-sn", surName01]
	    AdminTask.createUser(appOptions)
	    attrName1 = ["-uid",userName01]
	    userStr1 = AdminTask.searchUsers(attrName1)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName2 = ["-uid",userName02]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
            print "Skipping creating user " +  userName02 + " as user exists"
	else :
	    appOptions = ["-uid", userName02, "-password", "password", "-confirmPassword", "password", "-cn", userName02, "-sn", surName02]
	    AdminTask.createUser(appOptions)
	    attrName2 = ["-uid",userName02]
	    userStr2 =  AdminTask.searchUsers(attrName2)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr2,"-groupUniqueName",groupStr ]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName3 = ["-uid",userName03]
	if(len(AdminTask.searchUsers(attrName3)) > 1):
            print "Skipping creating user " +  userName03 + " as user exists"
	else :
	    appOptions = ["-uid", userName03, "-password", "password", "-confirmPassword", "password", "-cn", userName03, "-sn", surName03]
	    AdminTask.createUser(appOptions)
	    attrName3 = ["-uid",userName03]
	    userStr3 = AdminTask.searchUsers(attrName3)
	    groupStr = AdminTask.searchGroups(attrGrpBankManager)
	    appOptions = ["-memberUniqueName", userStr3, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName4 = ["-uid",userName04]
	if(len(AdminTask.searchUsers(attrName4)) > 1):
            print "Skipping creating user " +  userName04 + " as user exists"
	else :
	    appOptions = ["-uid", userName04, "-password", "password", "-confirmPassword", "password", "-cn", userName04, "-sn", surName04]
	    AdminTask.createUser(appOptions)
	    attrName4 = ["-uid",userName04]
	    userStr4 = AdminTask.searchUsers(attrName4)
	    groupStr = AdminTask.searchGroups(attrGrpBankManager)
	    appOptions = ["-memberUniqueName", userStr4, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	
except :
        print "Exception:Error occured while Group user creation and mapping"
        sys.stderr.write("Error occured while Group user creation and mapping")
        raise
        print "Group groupName"

#########################################################################
# Creating user and group and their mapping done
#########################################################################

#########################################################################
# Monitor Model Role Mapping begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName01 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName01 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName01 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName01 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName01 + "to role KPI-Administrator"




result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName02 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName02 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName02 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName02 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName02 + "to role KPI-Administrator"




result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName03 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName03 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName03 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName03 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName03 + "to role KPI-Administrator"




result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName04 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName04 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName04 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName04 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName04 + "to role KPI-Administrator"


#########################################################################
# Monitor Model Role Mapping is done.
#########################################################################
#######################################################################
# #Save configuration
#######################################################################
AdminConfig.save()
print "All the configurations are saved .."