#***********************************************************************
# Licensed Material - Property of IBM
#
# 
#
# (c) Copyright IBM Corp. 2009.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************
##################################################################
#
# Deploys Banking ICP ears.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop
#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')

refEarAppNameCCTI_Debulk = prop.getProperty('refEarAppNameCCTI_Debulk')
refEarFileNameCCTI_Debulk = prop.getProperty('refEarFileNameCCTI_Debulk')

refEarAppNameCCTI_Validation = prop.getProperty('refEarAppNameCCTI_Validation')
refEarFileNameCCTI_Validation = prop.getProperty('refEarFileNameCCTI_Validation')

refEarAppNameRules_Engine = prop.getProperty('refEarAppNameRules_Engine')
refEarFileNameRules_Engine = prop.getProperty('refEarFileNameRules_Engine')

refEarAppNameCommentECR = prop.getProperty('refEarAppNameCommentECR')
refEarFileNameCommentECR = prop.getProperty('refEarFileNameCommentECR')

refEarAppNameCorporate_Payments_Process = prop.getProperty('refEarAppNameCorporate_Payments_Process')
refEarFileNameCorporate_Payments_Process = prop.getProperty('refEarFileNameCorporate_Payments_Process')

refEarAppNameCorporate_Payments_Mock_Services = prop.getProperty('refEarAppNameCorporate_Payments_Mock_Services')
refEarFileNameCorporate_Payments_Mock_Services = prop.getProperty('refEarFileNameCorporate_Payments_Mock_Services')
#########################################################################
# Get mediation properties
#########################################################################
mediationAppName = prop.getProperty('mediationAppName')
mediationEarFileName = prop.getProperty('mediationEarFileName')
print "Configuration properties loaded."
#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupName = prop.getProperty('groupName')
groupNameBankManager = prop.getProperty('groupNameBankManager')
userName01 = prop.getProperty('userName01')
userName02 = prop.getProperty('userName02')
surName01 = prop.getProperty('surName01')
surName02 = prop.getProperty('surName02')
userName03 = prop.getProperty('userName03')
surName03 = prop.getProperty('surName03')
userName04 = prop.getProperty('userName04')
surName04 = prop.getProperty('surName04')
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
#
#
#########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')

#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
print "The order is: "     
fabricApplicationList = [refEarAppNameCCTI_Debulk, refEarAppNameCCTI_Validation, refEarAppNameRules_Engine, mmAppName, mediationAppName]
print "The List of uninstallable: " + str(fabricApplicationList)
unInstallApplications(fabricApplicationList)
#########################################################################
# Deleting users, groups and their mapping
#########################################################################
print
print "Deleting users, groups and their mapping ..."
try :
	attrName1 = ["-uid",userName01]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
	    print "Deleting user " + userName01 + " with group"
	    userStr1 =  AdminTask.searchUsers(attrName1)
	    attrGrp = ["-cn",groupName]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName01 + " from group"
	    appOptions = ["-uniqueName", userStr1]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName01
	    
	else :
	    print "User " + userName01 + " does not exist" 

	attrName2 = ["-uid",userName02]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
	    print "Deleting user with group " +  userName02
	    userStr2 =  AdminTask.searchUsers(attrName2)
	    attrGrp = ["-cn",groupName]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr2,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member from group " +  userName02
	    appOptions = ["-uniqueName", userStr2]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName02
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupName
	else :
	    print "User " + userName02 + " does not exist"

	attrName3 = ["-uid",userName03]
	if(len(AdminTask.searchUsers(attrName3)) > 1):
	    print "Deleting user with group " +  userName03
	    userStr3 =  AdminTask.searchUsers(attrName3)
	    attrGrp = ["-cn",groupNameBankManager]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr3,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName03 + " from group"
	    appOptions = ["-uniqueName", userStr3]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName03
	    
	else :
	    print "User " + userName03 + " does not exist" 

	attrName4 = ["-uid",userName04]
	if(len(AdminTask.searchUsers(attrName4)) > 1):
	    print "Deleting user with group " +  userName04
	    userStr4 =  AdminTask.searchUsers(attrName4)
	    attrGrp = ["-cn",groupNameBankManager]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr4,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member from group " +  userName04
	    appOptions = ["-uniqueName", userStr4]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName04
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupNameBankManager
	else :
	    print "User " + userName04 + " does not exist"

except :
        print "Exception:Error occured while deleting users, groups and their mapping "
        sys.stderr.write("Error occured while deleting users, groups and their mapping ")
        raise
        	
AdminConfig.save()
#########################################################################
# Monitor Model Role Mapping removal begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.removeRole("uid="+userName01+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName01 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName01 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName01+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName01+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName01+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01 + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName02 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName03+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName03 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName03 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName03+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName03+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName03+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03 + "to role KPI-Administrator"




result = rest_mbean.removeRole("uid="+userName04+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName04 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName04 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName04+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName04+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName04+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04 + "to role KPI-Administrator"


#########################################################################
# Monitor Model Role Mapping removed.
#########################################################################
AdminConfig.save()
#########################################################################
# End of file.
#########################################################################
