#***********************************************************************
# Licensed Material - Property of IBM
#
# 5724-M24
#
# (c) Copyright IBM Corp. 2008, 2010.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************
print "############################################################"
print "Creating the WebSphere variable on Node"
print "############################################################"
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from java.lang import System
#########################################################################
propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop
import sys
import java
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
##########################################################
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cellName = AdminControl.getCell();
print cellName
nodeName = AdminControl.getNode();
print nodeName
wsadminServer =AdminControl.queryNames("node=" + nodeName + ",type=Server,*" )
serverName = AdminControl.getAttribute(wsadminServer, "name" )
print serverName
variableVal = '${USER_INSTALL_ROOT}/banking-shared-libraries'
print "############################################################"
scope1 = cellName
scope2= nodeName
scope3 = 'Cell='+scope1+''
scope4= 'Node='+scope2+''
print "The scope is: " + scope3+scope4
scope5 = scope3+','+scope4+','+'Server='+serverName
print scope5
print '('+scope5+')'
print "############################################################"
############################################################
# Variables
############################################################
############################################################
lineSeparator = java.lang.System.getProperty('line.separator')
###########################################################
# Prints usage error 
###########################################################
def usageError(error):
    sys.stderr.write(error)
    print "Exception:Incorrect usage" + str(error)
    sys.exit()
###########################################################
# Prints error message on the console
###########################################################
def validationError (errorMessage) :
    sys.stderr.write(errorMessage)
    print "Exception:validationError" + str(errorMessage)
    raise
###########################################################
##########################################################
#Get websphere variables based on scope id : Cell id /Node id /Server id /Cluster id
##########################################################
##########################################################
def getWebsphereVariable(variablename,scope) :
    variableEntry = AdminConfig.list("VariableSubstitutionEntry",scope).splitlines()
    value = "";
    for ventry in variableEntry :
        name = AdminConfig.showAttribute(ventry,"symbolicName")
        if(name == variablename):
            value = AdminConfig.showAttribute(ventry,"value")
            break
    return value
##########################################################
##########################################################
## Set WebSphere Variable
try :
     print "Creating WebSphere variable.."
     AdminTask.setVariable(['-variableName', 'BANKING_SHARED_LIB_PATH', '-variableValue', variableVal, '-scope', (scope5)])
     AdminConfig.save()
     print "WebSphere variable created."
except :
	print "Failed to set BANKING_SHARED_LIB_PATH variable. You need to manually set the BANKING_SHARED_LIB_PATH variable."
###########################################################
AdminConfig.save()
print "############################################################"
#
print "Creating Shared Library"
#
print "############################################################"
#########################################################################
print "Configuration properties loaded."
#########################################################################
# Get connected cell/node/server name
#########################################################################
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
nodeName = AdminControl.getNode();
print nodeName
wsadminServer =AdminControl.queryNames("node=" + nodeName + ",type=Server,*" )
serverName = AdminControl.getAttribute(wsadminServer, "name" )
print serverName
print "############################################################"
print "Cell and Node names"
print "############################################################"
var1Cell = cell
var2Cell = '/Cell:'+cell+''
print var2Cell
var1Node = nodeName
var2Node = '/Node:'+nodeName+''
print var2Node
var1Server = serverName
var2Server = '/Server:'+var1Server+''
cellNodeServer = ''+var2Cell+''+var2Node+''+var2Server+''
print "The CellNodeServer is: " + cellNodeServer
print '('+cellNodeServer+'/)'
cns = AdminConfig.getid(cellNodeServer)
print cns
#######################################################################
# Library name and classpath
#########################################################################
libName = 'BankingSharedLibraries'
classpath = prop.getProperty('classpath')
#########################################################################
# create shared library ##
def createSharedLibrary(nodeName, serverName, libName, classpath, failonerror=AdminUtilities._BLANK_):
        if(failonerror==AdminUtilities._BLANK_): 
            failonerror=AdminUtilities._FAIL_ON_ERROR_
        #endIf
        msgPrefix = "createSharedLibrary("+`nodeName`+", "+`serverName`+", "+`libName`+", "+`classpath`+", "+`failonerror`+"): "

        try:
                #--------------------------------------------------------------------
                # Create shared library 
                #--------------------------------------------------------------------
                print ""
                print "---------------------------------------------------------------"
                print " AdminResources:         Create shared library"
                print " Scope:"
                print "    node                "+nodeName
                print "    server              "+serverName
                print " Shared library:"
                print "    name                "+libName
                print "    classpath           "+classpath
                print " Usage: AdminResources.createSharedLibrary(\""+nodeName+"\", \""+serverName+"\", \""+libName+"\", \""+classpath+"\")"
                print " Return: The configuration ID of the created Library in the respective cell"
                print "---------------------------------------------------------------"
                print " "
                print " "
                
                # check  the required arguments
                if (nodeName == ""):
                   raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["nodeName", nodeName]))
                
                if (serverName == ""):
                   raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["serverName", serverName]))

                if (libName == ""):
                   raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["libName", libName]))
                if (classpath == ""):
                   raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["classpath", classpath]))

                # check if node exists
                node = AdminConfig.getid("/Node:"+nodeName+"/")
                if (len(node) == 0):
                   raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6040E", ["nodeName", nodeName]))
                #endIf
                
                # check if server exists
                server = AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName)
                if (len(server) == 0):
                   raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6040E", ["serverName", serverName]))
                #endIf
                
                # Check if the Shared library already exists
                library = AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/Library:"+libName)
                if (len(library) > 0):
                   print "###############################################################"
		   print "The shared library 'BankingSharedLibraries' already exists."
		   print "###############################################################"
		   # raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6046E", [libName]))
		   raise SystemExit
                #endIf

                # Construct attributes
                attrs = [["name", libName], ["classPath", classpath], ["isolatedClassLoader", "true"], ["description", "WICP BankingSharedLibraries Library"]] 
                library = AdminConfig.create("Library", server, attrs)
                 
                AdminConfig.save()
                print "Shared library created."
		return library
		AdminConfig.save()
		print "Shared library created."

        except:
                typ, val, tb = sys.exc_info()
                if (typ==SystemExit):  raise SystemExit,`val`
                if (failonerror != AdminUtilities._TRUE_):
                    print "Exception: %s %s " % (sys.exc_type, sys.exc_value)
                    val = "%s %s" % (sys.exc_type, sys.exc_value)
                    raise "ScriptLibraryException: ", `val`
                else:
                    return AdminUtilities.fail(msgPrefix+AdminUtilities.getExceptionText(typ, val, tb), failonerror)
                #endIf
		AdminConfig.save()
        	#endTry
        AdminUtilities.infoNotice(AdminUtilities._OK_+msgPrefix)
        #return 1  # success
	AdminConfig.save()
#endDef

argsList = [nodeName, serverName, libName, classpath]
print "The List of shared Library args: " + str(argsList)
createSharedLibrary(nodeName, serverName, libName, classpath)
AdminConfig.list('ApplicationServer', cns)
appServer = AdminConfig.list('ApplicationServer', cns)
print appServer
#AdminConfig.create('Library', cns, '[[nativePath ""] [name "ModuleSharedLib"] [isolatedClassLoader true] [description "WICP Module Shared Library"] [classPath "${BANKING_SHARED_LIB_PATH}"]]')
AdminConfig.save()
print
print "############################################################"
print "Configuring Application Server Classloader "
print "############################################################"
print 
print "Configuration properties loaded."
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
nodeName = AdminControl.getNode();
print nodeName
wsadminServer =AdminControl.queryNames("node=" + nodeName + ",type=Server,*" )
serverName = AdminControl.getAttribute(wsadminServer, "name" )
print serverName
#######################################################################
# Cell and Node names
#########################################################################
var1Cell = cell
var2Cell = '/Cell:'+cell+''
print var2Cell
var1Node = nodeName
var2Node = '/Node:'+nodeName+''
print var2Node
var1Server = serverName
var2Server = '/Server:'+var1Server+''
cellNodeServer = ''+var2Cell+''+var2Node+''+var2Server+''
print "The CellNodeServer is: " + cellNodeServer
print '('+cellNodeServer+'/)'
cns = AdminConfig.getid(cellNodeServer)
print cns
fcns = '('+cns+')'
print ''+cns+''
print "############################################################"
print "ApplicationServerClassloader configuration"
print "############################################################"
policy = 'MULTIPLE'
print policy
mode = 'PARENT_FIRST'
print mode
libraryName = 'BankingSharedLibraries'
print libraryName
print "############################################################"
# Configure application server classloader #
def configureApplicationServerClassloader(nodeName, serverName, policy, mode, libraryName, failonerror=AdminUtilities._BLANK_):
    if(failonerror==AdminUtilities._BLANK_): 
        failonerror=AdminUtilities._FAIL_ON_ERROR_
    #endIf
    msgPrefix = "configureApplicationServerClassloader("+`nodeName`+", "+`serverName`+", "+`policy`+", "+`mode`+", "+`libraryName`+", "+`failonerror`+"): "

    try:
        #--------------------------------------------------------------------
        # Configure ApplicationServer Classloader
        #--------------------------------------------------------------------
        print "---------------------------------------------------------------"
        print " AdminServerManagement:          Configure ApplicationServer classloader"
        print " nodeName:                       "+nodeName
        print " serverName:                     "+serverName
        print " policy:                         "+policy
        print " mode:                           "+mode
        print " libraryName:                    "+libraryName
        print " Usage: AdminServerManagement.configureApplicationServerClassloader(\""+nodeName+"\", \""+serverName+"\", \""+policy+"\", \""+mode+"\", \""+libraryName+"\")"
        print " Return: If the command is successful, a value of 1 is returned."
        print "---------------------------------------------------------------"
        print " "
        print " "

        # checking required parameters
        # WASL6041E=WASL6041E: Invalid parameter value: {0}:{1}
        if (len(nodeName) == 0):
            raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["nodeName", nodeName]))
            
        if (len(serverName) == 0):
            raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["serverName", serverName]))

        if (len(policy) == 0):
            raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["policy", policy]))

        if (len(mode) == 0):
            raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["mode", mode]))

        if (len(libraryName) == 0):
            raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6041E", ["libraryName", libraryName]))

	# checking if the parameter value exists
	# WASL6040E=WASL6040E: The specified argument {0}:{1} does not exist.
        nodeExist = AdminConfig.getid("/Node:"+nodeName+"/")
	if (len(nodeExist) == 0):
	    raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6040E", ["nodeName", nodeName]))
	
	serverExist = AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")
	if (len(serverExist) == 0):
	    raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6040E", ["serverName", serverName]))
            
        # contruct required attributes
        requiredAttrs = [["applicationClassLoaderPolicy", policy], ["applicationClassLoadingMode", mode]]

        server = AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/")
	apss = AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/ApplicationServer:"+"/")
        apsList = AdminUtilities.convertToList(apss)

	# check if there is more then one exists
	# WASL6045E=WASL6045E: Multiple {0} found in your configuration.  
	aps = AdminUtilities._BLANK_
	if (len(apsList) > 1):
	    raise AttributeError(AdminUtilities._formatNLS(resourceBundle, "WASL6045E", ["ApplicationServer"]))
	    return -1
	if (len(apsList) == 1):
            aps = apsList[0]
	    AdminConfig.modify(aps, requiredAttrs)
	if (len(apsList) == 0):
	    aps = AdminConfig.create("ApplicationServer", server, requiredAttrs)

        # get Classloader
	cls = AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/ApplicationServer:"+"/Classloader:/")
        clList = AdminUtilities.convertToList(cls)

	libs = AdminConfig.getid("/Node:"+nodeName+"/Server:"+serverName+"/ApplicationServer:"+"/Classloader:/LibraryRef:/")
        libList = AdminUtilities.convertToList(libs)
	libFound = "false"
	for lib in libList:
	    libName = AdminConfig.showAttribute(lib, "libraryName")
	    if (libName == libraryName):
	        libFound = "true"
	############################################################
	if (libFound == "false"):
	        cl = AdminConfig.create("Classloader", aps, [["mode", mode]])
	        lib = AdminConfig.create("LibraryRef", cl, [["libraryName", libraryName]])

	AdminConfig.save()        
        print AdminConfig.showall(aps)
        print "The classloading configuration has been performed."
	return 1
    except:
        typ, val, tb = sys.exc_info()
        if(typ==SystemExit):  raise SystemExit,`val`
        if (failonerror != AdminUtilities._TRUE_):
            print "Exception: %s %s " % (sys.exc_type, sys.exc_value)
	    val = "%s %s" % (sys.exc_type, sys.exc_value)
	    raise "ScriptLibraryException: ", `val`
            return -1
        else:
            return AdminUtilities.fail(msgPrefix+AdminUtilities.getExceptionText(typ, val, tb), failonerror)
        #endIf
    #endTry
    AdminUtilities.infoNotice(AdminUtilities._OK_+msgPrefix)
#endDef
############################################################
argsList = [nodeName, serverName, policy, mode, libraryName]
print "The List of configureApplicationServerClassloader args: " + str(argsList)
AdminConfig.list('Classloader', cns)
varAdminConfigList = AdminConfig.list('Classloader', cns)
print "The AdminConfigList is: " + varAdminConfigList
configureApplicationServerClassloader(nodeName, serverName, policy, mode, libraryName)
AdminConfig.save()
print "############################################################"